; 
    include \masm32\include\masm32rt.inc
; 

    .686p
    .MMX
    .XMM

; 

    include bm.inc

    run_benchmarks PROTO
    format_num_string PROTO :DWORD,:DWORD

    utoa PROTO :DWORD,:DWORD
    utoa_ex PROTO :DWORD,:DWORD


    .code

start:

    GLOBAL hInstance dd ?
    mov hInstance, FUNC(GetModuleHandle, NULL)

  ; -------------------------------------------
  ; Call the dialog box from the resource file
  ; -------------------------------------------
    invoke DialogBoxParam,hInstance,100,0,ADDR WndProc0,0

    invoke ExitProcess,eax

; 

WndProc0 proc hWin   :DWORD,
              uMsg   :DWORD,
              wParam :DWORD,
              lParam :DWORD

    LOCAL icce:INITCOMMONCONTROLSEX
    LOCAL bstyle    :DWORD

      STRING dlgTitle0,"Benchmark"
      GLOBAL hWnd       dd ?

    ; -----------------------
    ; Dialog control handles
    ; -----------------------
      GLOBAL h0Butn1    dd ?
      GLOBAL h0Butn2    dd ?

      GLOBAL hBar1      dd ?
      GLOBAL hBar2      dd ?
      GLOBAL hBar3      dd ?
      GLOBAL hBar4      dd ?

      GLOBAL title1     dd ?
      GLOBAL title2     dd ?
      GLOBAL title3     dd ?
      GLOBAL title4     dd ?

      GLOBAL rslt1      dd ?
      GLOBAL rslt2      dd ?
      GLOBAL rslt3      dd ?
      GLOBAL rslt4      dd ?

      GLOBAL working    dd ?

      .if uMsg == WM_INITDIALOG
        m2m hWnd, hWin    ; Copy hWin to GLOBAL variable
        invoke SendMessage,hWin,WM_SETTEXT,0,ADDR dlgTitle0
        invoke SendMessage,hWin,WM_SETICON,1,FUNC(LoadIcon,hInstance,2)

        fn SetWindowText,hWin,"Unsigned DWORD to ASCII Benchmark"

      ; --------------------------------------
      ; comment out the styles you don't need.
      ; --------------------------------------
        mov icce.dwSize, SIZEOF INITCOMMONCONTROLSEX            ; set the structure size
        xor eax, eax                                            ; set EAX to zero
        or eax, ICC_ANIMATE_CLASS                               ; OR as many styles as you need to it
        or eax, ICC_BAR_CLASSES                                 ; comment out the rest
        or eax, ICC_COOL_CLASSES
        or eax, ICC_DATE_CLASSES
        or eax, ICC_HOTKEY_CLASS
        or eax, ICC_INTERNET_CLASSES
        or eax, ICC_LISTVIEW_CLASSES
        or eax, ICC_PAGESCROLLER_CLASS
        or eax, ICC_PROGRESS_CLASS
        or eax, ICC_TAB_CLASSES
        or eax, ICC_TREEVIEW_CLASSES
        or eax, ICC_UPDOWN_CLASS
        or eax, ICC_USEREX_CLASSES
        or eax, ICC_WIN95_CLASSES
        mov icce.dwICC, eax
        invoke InitCommonControlsEx,ADDR icce                   ; initialise the common control library
      ; --------------------------------------

      ; --------------------------------
      ; Get the handle for each control
      ; --------------------------------

      ; buttons

        mov h0Butn1,    rv(GetDlgItem,hWin,101)
        mov h0Butn2,    rv(GetDlgItem,hWin,102)

      ; label text

        mov title1,     rv(GetDlgItem,hWin,300)
        mov title2,     rv(GetDlgItem,hWin,301)
        mov title3,     rv(GetDlgItem,hWin,302)
        mov title4,     rv(GetDlgItem,hWin,303)

      ; progress bars

        mov hBar1,      rv(GetDlgItem,hWin,200)
        mov hBar2,      rv(GetDlgItem,hWin,201)
        mov hBar3,      rv(GetDlgItem,hWin,202)
        mov hBar4,      rv(GetDlgItem,hWin,203)

        mov rslt1,      rv(GetDlgItem,hWin,500)
        mov rslt2,      rv(GetDlgItem,hWin,501)
        mov rslt3,      rv(GetDlgItem,hWin,502)
        mov rslt4,      rv(GetDlgItem,hWin,503)

      ; text display area

        mov working,    rv(GetDlgItem,hWin,400)

        fn SetWindowText,title1,"utoa"
        fn SetWindowText,title2,"utoa_ex"
        fn SetWindowText,title3,"udw2str"
        fn SetWindowText,title4,"unused"

        xor eax, eax
        ret

      .elseif uMsg == WM_COMMAND
        .if wParam == 101           ; start button
          invoke run_benchmarks

        .elseif wParam == 102       ; close button
          jmp exit_dialog0

        .endif

      .elseif uMsg == WM_CLOSE
        exit_dialog0:
        invoke EndDialog,hWin,0

      .endif

    xor eax, eax
    ret

WndProc0 endp

; 

    iterate equ <10000000>

run_benchmarks proc

    LOCAL pbuf  :DWORD
    LOCAL buffer[32]:BYTE

    LOCAL dbuf  :DWORD
    LOCAL dbuffr[128]:BYTE

    LOCAL tm1   :DWORD
    LOCAL tm2   :DWORD
    LOCAL tm3   :DWORD

    LOCAL av1   :DWORD
    LOCAL av2   :DWORD
    LOCAL av3   :DWORD

    LOCAL range :DWORD

    LOCAL pcnt  :DWORD

    push ebx
    push esi
    push edi

    invoke SendMessage,hBar1,PBM_SETPOS,0,0
    invoke SendMessage,hBar2,PBM_SETPOS,0,0
    invoke SendMessage,hBar3,PBM_SETPOS,0,0

    fn SetWindowText,rslt1,0
    fn SetWindowText,rslt2,0
    fn SetWindowText,rslt3,0

    mov pbuf, ptr$(buffer)

  ; ----------------
  ; CALIBRATION CODE
  ; ----------------
    fn SetWindowText,working,"Calibrating Algorithms"

  ; ==========================

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke utoa,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    mov tm1, eax

  ; ==========================

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke utoa_ex,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    mov tm2, eax

  ; ==========================

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke udw2str,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    mov tm3, eax

  ; ==========================

    mov eax, tm1
    mov ecx, tm2
    mov edx, tm3

  ; ----------------------------------------------
  ; calculate the longest time of the slowest algo
  ; ----------------------------------------------
    mov range, eax
    .if ecx > range
      mov range, ecx
    .endif

    .if edx > range
      mov range, edx
    .endif

  ; ---------------------------------------------------------
  ; add 50% to it to improve the display of the progress bars
  ; ---------------------------------------------------------
    mov eax, range
    shr eax, 1
    add range, eax

    invoke SendMessage,hBar1,PBM_SETRANGE32,0,range
    invoke SendMessage,hBar2,PBM_SETRANGE32,0,range
    invoke SendMessage,hBar3,PBM_SETRANGE32,0,range

    fn SetWindowText,working,"Calibrating pass results"

    invoke SendMessage,hBar1,PBM_SETPOS,tm1,0
    invoke SendMessage,hBar2,PBM_SETPOS,tm2,0
    invoke SendMessage,hBar3,PBM_SETPOS,tm3,0

    fn SetWindowText,rslt1,str$(tm1)
    fn SetWindowText,rslt2,str$(tm2)
    fn SetWindowText,rslt3,str$(tm3)

    mov av1, 0
    mov av2, 0
    mov av3, 0

    mov pcnt, 0

  ; ------------------
  ; The BENCHMARK CODE
  ; ------------------
  REPEAT 8

    add pcnt, 1

    mov dbuf, ptr$(dbuffr)

    mov dbuf, cat$(dbuf,"Timing pass ",str$(pcnt))

    fn SetWindowText,working,dbuf

  ; ==========================

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke utoa,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    add av1, eax

  ; ==========================

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke utoa_ex,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    add av2, eax

  ; ==========================

    invoke GetTickCount
    push eax

    mov esi, iterate
  @@:
    invoke udw2str,esi,pbuf
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    add av3, eax

  ; ==========================

  ENDM

    fn SetWindowText,working,"Average results for 8 passes"

    shr av1, 3
    shr av2, 3
    shr av3, 3

    invoke SendMessage,hBar1,PBM_SETPOS,av1,0
    invoke SendMessage,hBar2,PBM_SETPOS,av2,0
    invoke SendMessage,hBar3,PBM_SETPOS,av3,0

    fn SetWindowText,rslt1,str$(av1)
    fn SetWindowText,rslt2,str$(av2)
    fn SetWindowText,rslt3,str$(av3)

    pop edi
    pop esi
    pop ebx

    ret

run_benchmarks endp

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 16

utoa proc src:DWORD, lpdest:DWORD

  ; ----------------------------------------------------------------------
  ; This is a modified version of an algorithm written by Ray Filiatreault
  ; ----------------------------------------------------------------------

    mov eax, [esp+4]            ; src
    mov ecx, [esp+8]            ; lpdest             ; buffer address

    push esi
    push ecx                    ; save dest address

    sub ecx, 1
    mov esi, 0CCCCCCCDh         ; "magic number" multiplier for division by 10
    mov DWORD PTR [esp+16], 10

  @@:
    mul esi                     ; multiply by magic number
    shrd eax, edx, 3            ; binary fractional "remainder" back in EAX
    shr edx, 3                  ; EDX = quotient
    add eax, 1                  ; precaution against occasional "underflow"
    mov [esp+12], edx           ; save current quotient for next division
    mul DWORD PTR [esp+16]      ; x10 gets "decimal" remainder into EDX
    add ecx, 1                  ; increment digit in buffer
    add dl, 30h                 ; convert remainder to ascii
    mov [ecx], dl               ; insert it into buffer
    mov eax, [esp+12]           ; retrieve current quotient
    test eax, eax               ; test if done
    jnz @B                      ; continue if not done

    mov byte ptr [ecx+1], 0     ; terminate the string
    mov esi, [esp]              ; copy the dest address into ESI

  @@:
    movzx eax, BYTE PTR [esi]   ; reverse the string
    movzx edx, BYTE PTR [ecx]
    mov [esi], dl
    mov [ecx], al
    add esi, 1
    sub ecx, 1
    cmp esi, ecx
    jb @B

    pop eax                     ; restore and return dest address
    pop esi

    ret 8

utoa endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

;  

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

    align 16

utoa_ex proc uvar:DWORD,pbuffer:DWORD

  ; --------------------------------------------------------------------------------
  ; this algorithm was written by Paul Dixon and has been converted to MASM notation
  ; --------------------------------------------------------------------------------

    mov eax, [esp+4]                ; uvar      : unsigned variable to convert
    mov ecx, [esp+8]                ; pbuffer   : pointer to result buffer

    push esi
    push edi

    jmp udword

  align 4
  chartab:
    dd "00","10","20","30","40","50","60","70","80","90"
    dd "01","11","21","31","41","51","61","71","81","91"
    dd "02","12","22","32","42","52","62","72","82","92"
    dd "03","13","23","33","43","53","63","73","83","93"
    dd "04","14","24","34","44","54","64","74","84","94"
    dd "05","15","25","35","45","55","65","75","85","95"
    dd "06","16","26","36","46","56","66","76","86","96"
    dd "07","17","27","37","47","57","67","77","87","97"
    dd "08","18","28","38","48","58","68","78","88","98"
    dd "09","19","29","39","49","59","69","79","89","99"

  udword:
    mov esi, ecx                    ; get pointer to answer
    mov edi, eax                    ; save a copy of the number

    mov edx, 0D1B71759h             ; =2^45\10000    13 bit extra shift
    mul edx                         ; gives 6 high digits in edx

    mov eax, 68DB9h                 ; =2^32\10000+1

    shr edx, 13                     ; correct for multiplier offset used to give better accuracy
    jz short skiphighdigits         ; if zero then don; t need to process the top 6 digits

    mov ecx, edx                    ; get a copy of high digits
    imul ecx, 10000                 ; scale up high digits
    sub edi, ecx                    ; subtract high digits from original. EDI now = lower 4 digits

    mul edx                         ; get first 2 digits in edx
    mov ecx, 100                    ; load ready for later

    jnc short next1                 ; if zero, supress them by ignoring
    cmp edx, 9                      ; 1 digit or 2?
    ja  short ZeroSupressed         ; 2 digits, just continue with pairs of digits to the end

    mov edx, chartab[edx*4]         ; look up 2 digits
    mov [esi], dh                   ; but only write the 1 we need, supress the leading zero
    inc esi                         ; update pointer by 1
    jmp short ZS1                   ; continue with pairs of digits to the end

  next1:
    mul ecx                         ; get next 2 digits
    jnc short next2                 ; if zero, supress them by ignoring
    cmp edx, 9                      ; 1 digit or 2?
    ja  short ZS1a                  ; 2 digits, just continue with pairs of digits to the end

    mov edx, chartab[edx*4]         ; look up 2 digits
    mov [esi], dh                   ; but only write the 1 we need, supress the leading zero
    inc esi                         ; update pointer by 1
    jmp short ZS2                   ; continue with pairs of digits to the end

  next2:
    mul ecx                         ; get next 2 digits
    jnc short next3                 ; if zero, supress them by ignoring
    cmp edx, 9                      ; 1 digit or 2?
    ja  short ZS2a                  ; 2 digits, just continue with pairs of digits to the end

    mov edx, chartab[edx*4]         ; look up 2 digits
    mov [esi], dh                   ; but only write the 1 we need, supress the leading zero
    inc esi                         ; update pointer by 1
    jmp short ZS3                   ; continue with pairs of digits to the end

  next3:

  skiphighdigits:
    mov eax, edi                    ; get lower 4 digits

    mov ecx, 100

    mov edx, 28F5C29h               ; 2^32\100 +1
    mul edx
    jnc short next4                 ; if zero, supress them by ignoring
    cmp edx, 9                      ; 1 digit or 2?
    ja  short ZS3a                  ; 2 digits, just continue with pairs of digits to the end

    mov edx, chartab[edx*4]         ; look up 2 digits
    mov [esi], dh                   ; but only write the 1 we need, supress the leading zero
    inc esi                         ; update pointer by 1
    jmp short  ZS4                  ; continue with pairs of digits to the end

  next4:
    mul ecx                         ; this is the last pair so don; t supress a single zero
    cmp edx, 9                      ; 1 digit or 2?
    ja  short ZS4a                  ; 2 digits, just continue with pairs of digits to the end

    mov edx, chartab[edx*4]         ; look up 2 digits
    mov [esi], dh                   ; but only write the 1 we need, supress the leading zero
    mov byte ptr [esi+1], 0         ; zero terminate string

    jmp short  sdwordend            ; all done

  ZeroSupressed:
    mov edx, chartab[edx*4]         ; look up 2 digits
    mov [esi], dx
    add esi, 2                      ; write them to answer

  ZS1:
    mul ecx                         ; get next 2 digits
  ZS1a:
    mov edx, chartab[edx*4]         ; look up 2 digits
    mov [esi], dx                   ; write them to answer
    add esi, 2

  ZS2:
    mul ecx                         ; get next 2 digits
  ZS2a:
    mov edx, chartab[edx*4]         ; look up 2 digits
    mov [esi], dx                   ; write them to answer
    add esi, 2

  ZS3:
    mov eax, edi                    ; get lower 4 digits
    mov edx, 28F5C29h               ; 2^32\100 +1
    mul edx                         ; edx= top pair
  ZS3a:
    mov edx, chartab[edx*4]         ; look up 2 digits
    mov [esi], dx                   ; write to answer
    add esi, 2                      ; update pointer

  ZS4:
    mul ecx                         ; get final 2 digits
  ZS4a:
    mov edx, chartab[edx*4]         ; look them up
    mov [esi], dx                   ; write to answer

    mov byte ptr [esi+2], 0         ; zero terminate string

  sdwordend:

    pop edi
    pop esi

    ret 8

utoa_ex endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

;  

end start












